-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

in  { config =
        Genode.Init::{
        , verbose = True
        , children =
            toMap
              { test-signal =
                  Genode.Init.Start::{
                  , binary = "test-signal"
                  , exitPropagate = True
                  , resources = { caps = 500, ram = Genode.units.MiB 10 }
                  }
              }
        }
    , rom =
        let manifest = env:MANIFEST
        
        in  Genode.Boot.toRomPaths [ manifest.os.bin.test-signal ]
    }
